function ending(enddataid)
	local enddata = mmf.newObject(enddataid)
	
	enddata.values[ENDTIMER] = enddata.values[ENDTIMER] + 1
	local phase = enddata.values[ENDPHASE]
	local timer = enddata.values[ENDTIMER]
	local ender = enddata.values[4]
	local ended = enddata.values[3]
	
	if (phase == 1) then
		if (timer == 2) then
			local unit = mmf.newObject(ended)
			local c1,c2 = getcolour(ended)
			MF_particles("smoke",unit.values[XPOS],unit.values[YPOS],20,c1,c2,1)
			
			unit.visible = false
			
			local flowerid = MF_specialcreate("Flower_center")
			local flower = mmf.newObject(flowerid)
			
			flower.strings[2] = "you"
			flower.values[10] = 1
			flower.values[8] = 15
			flower.x = tilesize * unit.values[XPOS] * spritedata.values[TILEMULT] + tilesize * 0.5 * spritedata.values[TILEMULT]
			flower.y = tilesize * unit.values[YPOS] * spritedata.values[TILEMULT] + tilesize * 0.5 * spritedata.values[TILEMULT]
		end
		
		if (timer > 0) then
			for i,unit in ipairs(units) do
				if (unit.strings[UNITTYPE] == "text") then
					unit.x = unit.x + math.random(-1,1)
					unit.y = unit.y + math.random(-1,1)
					unit.values[POSITIONING] = 0
				end
			end
		end
		
		if (timer == 140) then
			local textconverts = {}
			
			for i,unit in ipairs(units) do
				if (unit.strings[UNITTYPE] == "text") then
					table.insert(textconverts, unit)
				end
			end
			
			for i,unit in pairs(textconverts) do
				doconvert({unit.fixed,"convert","blossom",unit.values[ID],unit.values[ID]})
				updatecode = 0
			end
		end
		
		if (timer > 140) then
			local eunit = mmf.newObject(ender)
			local changethese = {}
			local deletethese = {}
			local blossoms = {}
			
			for i,unit in ipairs(units) do
				if (unit.strings[UNITNAME] == "blossom") then
					if (unit.values[FLOAT] == 3) then
						if (unit.values[XPOS] == eunit.values[XPOS]) and (unit.values[YPOS] == eunit.values[YPOS]) then
							table.insert(changethese, unit)
						end
					elseif (unit.values[FLOAT] == 0) and (timer > 150) then
						local edunit = mmf.newObject(ended)
						
						unit.values[XPOS] = unit.values[XPOS] + (edunit.values[XPOS] - unit.values[XPOS]) * 0.2
						unit.values[YPOS] = unit.values[YPOS] + (edunit.values[YPOS] - unit.values[YPOS]) * 0.2
						unit.values[POSITIONING] = 0
						
						local dist = math.abs(edunit.values[XPOS] - unit.values[XPOS]) + math.abs(edunit.values[YPOS] - unit.values[YPOS])
						
						if (dist < 0.5) then
							table.insert(deletethese, unit)
						end
					end
					table.insert(blossoms, 1)
				end
			end
			
			for i,unit in ipairs(deletethese) do
				MF_particles("bling",unit.values[XPOS],unit.values[YPOS],10,0,3,1)
				delete(unit.fixed)
				updatecode = 0
			end
			
			for i,unit in ipairs(changethese) do
				MF_particles("bling",unit.values[XPOS],unit.values[YPOS],10,0,3,1)
				unit.values[FLOAT] = 0
			end
			
			if (#blossoms == 0) then
				enddata.values[ENDPHASE] = 2
				enddata.values[ENDTIMER] = 0
			end
		end
	end
		
	if (phase == 2) then
		if (timer == 30) then
			local allis = MF_findspecial("you")
			
			for i,flowerid in ipairs(allis) do
				local flower = mmf.newObject(flowerid)
				flower.values[6] = 3
			end
		end
		
		if (timer == 210) then
			local allis = MF_findspecial("you")
			
			for i,flowerid in ipairs(allis) do
				local flower = mmf.newObject(flowerid)
				flower.values[6] = 1
			end
		end
		
		if (timer == 430) then
			dotransition()
		elseif (timer > 430) and (generaldata.values[TRANSITIONED] == 1) then
			clearunits()
			MF_loop("clear",1)
			
			enddata.values[ENDPHASE] = 3
			enddata.values[ENDTIMER] = 0
			generaldata.values[ONLYARROWS] = 0
			generaldata.values[IGNORE] = 1
			generaldata.values[TRANSITIONED] = 0
			
			local xoffset = (screenw - roomsizex * tilesize * spritedata.values[TILEMULT]) * 0.5
			local yoffset = (screenh - roomsizey * tilesize * spritedata.values[TILEMULT]) * 0.5
			
			MF_setroomoffset(xoffset,yoffset)
			MF_loadbackimage("island,island_decor")
			levelborder()
			
			local flowerid = MF_specialcreate("Flower_center")
			local flower = mmf.newObject(flowerid)
			
			flower.strings[2] = "endingflower"
			flower.values[10] = 1
			flower.values[8] = 2
			flower.values[6] = 1
			flower.x = tilesize * 16 * spritedata.values[TILEMULT]
			flower.y = tilesize * 14 * spritedata.values[TILEMULT]
			
			local otherareas =
			{
				{
					name = "mountain",
					xpos = 10,
					ypos = 3,
					colour = {1,4},
					level = "232level",
				},
				{
					name = "cave",
					xpos = 11,
					ypos = 5,
					colour = {2,2},
					level = "179level",
				},
				{
					name = "garden",
					xpos = 13,
					ypos = 8,
					colour = {4,1},
					level = "180level",
				},
				{
					name = "ruins",
					xpos = 18,
					ypos = 6,
					colour = {2,4},
					level = "206level",
				},
				{
					name = "space",
					xpos = 20,
					ypos = 4,
					colour = {3,2},
					level = "87level",
				},
				{
					name = "forest",
					xpos = 21,
					ypos = 6,
					colour = {5,2},
					level = "169level",
				},
				{
					name = "island",
					xpos = 18,
					ypos = 9,
					colour = {5,3},
					level = "207level",
				},
				{
					name = "lake",
					xpos = 16,
					ypos = 10,
					colour = {1,4},
					level = "177level",
				},
				{
					name = "fall",
					xpos = 21,
					ypos = 13,
					colour = {2,3},
					level = "16level",
				},
				{
					name = "abstract",
					xpos = 24,
					ypos = 10,
					colour = {0,2},
					level = "182level",
				},
			}
			
			for i,v in ipairs(otherareas) do
				local status = tonumber(MF_read("save",generaldata.strings[WORLD] .. "_complete",v.level))
				
				if (status == 1) then
					local flowerid = MF_specialcreate("Flower_center")
					local flower = mmf.newObject(flowerid)
					
					flower.strings[1] = tostring(v.colour[1]) .. "," .. tostring(v.colour[2])
					flower.strings[2] = "otherarea"
					flower.values[10] = 2
					flower.values[8] = 1
					flower.values[6] = 1
					flower.x = Xoffset + (v.xpos * tilesize + tilesize * 0.5) * spritedata.values[TILEMULT]
					flower.y = Yoffset + (v.ypos * tilesize + tilesize * 0.5) * spritedata.values[TILEMULT]
				end
			end
		end
	end
	
	if (phase == 3) then
		if (timer == 600) then
			local mx = screenw * 0.5
			local my = screenh * 0.5
			
			--[[
			for i=1,20 do
				local vblobid = MF_specialcreate("Victoryblob")
				local vblob = mmf.newObject(vblobid)
				local offset = math.random(-240,240)
				vblob.values[XPOS] = mx + offset
				vblob.values[YPOS] = my
				vblob.values[ONLINE] = 1
				vblob.values[6] = math.abs(mx - vblob.values[XPOS]) * 0.05
				vblob.scaleX = 0.01
				vblob.scaleY = 0.01
				vblob.layer = 2
				vblob.angle = math.random(0,359)
				MF_setcolour(vblobid,1,0)
			end
			]]--
			
			local letid1 = MF_effectcreate("Ending_theend")
			local letid2 = MF_effectcreate("Ending_theend")
			local let1 = mmf.newObject(letid1)
			local let2 = mmf.newObject(letid2)
			
			let1.x = mx
			let1.y = my + 4
			let1.layer = 2
			MF_setcolour(letid1,1,2)
			
			let2.x = mx
			let2.y = my
			let2.layer = 2
		elseif (timer == 650) then
			local mx = screenw * 0.5
			local my = screenh * 0.5
			
			local letid3 = MF_effectcreate("Ending_theend_back")
			local let3 = mmf.newObject(letid3)
			let3.x = mx
			let3.y = my + 8
			let3.layer = 2
		elseif (timer == 1050) then
			dotransition()
		elseif (timer > 1050) and (generaldata.values[TRANSITIONED] == 1) then
			clearunits()
			MF_loop("clear",1)
			MF_setmode(2)
			enddata.values[ENDPHASE] = 0
			enddata.values[ENDTIMER] = 0
			enddata.values[ENDCREDITS] = 1
			generaldata.values[IGNORE] = 0
		end
	end
end

function dointro(introdataid)
	local flowers =
	{	
		baba =
		{
			start = 200,
			wait_until_open = 70,
			wait_until_reveal = 130,
			what_to_reveal = "text_baba",
			
			position = true,
			shake = {"baba", 130, 230},
			wait_until_position = 100,
			what_to_position = "baba",
			
			disregard_after = 235,
			
			particles = true,
			
			appear_sound = "intro_reveal_1f",
			--open_sound = "intro_open_1b",
			disappear_sound = "intro_disappear_1",
		},
		
		wall =
		{
			start = 600,
			wait_until_open = 70,
			wait_until_reveal = 130,
			what_to_reveal = "text_wall",
			
			position = true,
			shake = {"wall", 130, 230},
			wait_until_position = 100,
			what_to_position = "wall",
			
			disregard_after = 235,
			
			particles = true,
			
			appear_sound = "intro_reveal_2f",
			disappear_sound = "intro_disappear_2",
		},
		
		rock =
		{
			start = 1000,
			wait_until_open = 70,
			wait_until_reveal = 130,
			what_to_reveal = "text_rock",
			
			position = true,
			shake = {"rock", 130, 230},
			wait_until_position = 100,
			what_to_position = "rock",
			
			disregard_after = 235,
			
			particles = true,
			
			appear_sound = "intro_reveal_3f",
			disappear_sound = "intro_disappear_3",
		},
		
		flag =
		{
			start = 1350,
			wait_until_open = 70,
			wait_until_reveal = 130,
			what_to_reveal = "text_flag",
			
			position = true,
			shake = {"flag", 130, 230},
			wait_until_position = 100,
			what_to_position = "flag",
			
			disregard_after = 235,
			
			particles = true,
			
			appear_sound = "intro_reveal_4f",
			disappear_sound = "intro_disappear_4",
		},
	}
	local introdata = mmf.newObject(introdataid)
	
	local timer = introdata.values[INTROTIMER]
	local phase = introdata.values[INTROPHASE]
	
	timer = timer + 1
	introdata.values[INTROTIMER] = timer
	
	if (phase == 2) then
		for a,b in pairs(flowers) do
			if (b.start <= timer) and (b.start + b.wait_until_open + b.wait_until_reveal + b.disregard_after >= timer) then
				if (timer == b.start) then
					for i,unit in ipairs(units) do
						if (unit.strings[UNITNAME] == b.what_to_reveal) then
							local flowerid = MF_specialcreate("Flower_center")
							local flower = mmf.newObject(flowerid)
							
							flower.strings[2] = a
							flower.x = unit.x
							flower.y = unit.y
						end
					end
					
					if (b.appear_sound ~= nil) then
						MF_playsound(b.appear_sound)
					end
				elseif (timer == b.start + b.wait_until_open) then
					local flowerids = MF_findspecial(a)
			
					if (#flowerids > 0) then
						for i,flowerid in ipairs(flowerids) do
							local flower = mmf.newObject(flowerid)
							
							flower.values[6] = 1
						end
					end
					
					if (b.open_sound ~= nil) then
						MF_playsound(b.open_sound)
					end
				elseif (timer == b.start + b.wait_until_open + b.wait_until_reveal) then
					local flowerids = MF_findspecial(a)
			
					if (#flowerids > 0) then
						for i,flowerid in ipairs(flowerids) do
							local flower = mmf.newObject(flowerid)
							
							flower.values[6] = 2
						end
					end
					
					for i,unit in ipairs(units) do
						if (unit.strings[UNITNAME] == b.what_to_reveal) then
							unit.visible = true
						end
					end
					
					if (b.disappear_sound ~= nil) then
						MF_playsound(b.disappear_sound)
					end
				elseif (timer == b.start + b.wait_until_open + b.wait_until_reveal + b.wait_until_position) and b.position then
					for i,unit in ipairs(units) do
						if (unit.strings[UNITNAME] == b.what_to_position) then
							unit.values[FLOAT] = 0
							unit.values[POSITIONING] = -10
							
							local unitref = unitreference[unit.strings[UNITNAME]]
							local thisdata = tileslist[unitref]
							local changedata = changes[unitref] or {}
							
							local c = changedata.colour or thisdata.colour
							MF_setcolour(unit.fixed, c[1], c[2])
							unit.values[ZLAYER] = thisdata.layer
						end
					end
					
					if (b.what_to_position == "flag") then
						introdata.values[INTROPHASE] = 3
						introdata.values[INTROTIMER] = 0
					end
					
					local freq = 44000 + math.random(-9000,9000)
					MF_playsound_full("whoooooosh_loud",0,0,freq)
				end
				
				if (b.shake ~= nil) then
					local shakedata = b.shake
					
					if (timer > b.start + b.wait_until_open + shakedata[2]) and (timer < b.start + b.wait_until_open + shakedata[3]) then
						for i,unit in ipairs(units) do
							if (unit.strings[UNITNAME] == shakedata[1]) then
								unit.x = unit.x + math.random(-2, 2)
								unit.y = unit.y + math.random(-2, 2)
								
								if b.particles and (timer % 3 == 0) then
									local tx = (unit.x - Xoffset) / tilesize
									local ty = (unit.y - Yoffset) / tilesize
									particles("bling",tx,ty,1,{1, 1},0)
								end
							end
						end
					end
				end
			end
		end
	elseif (phase == 3) then
		local curris = math.floor(timer / 20) - 7
		local allis = {}
		
		if (curris > 7) then
			curris = curris - 3
		elseif (curris >= 5) and (curris <= 7) then
			curris = -1
		end
		
		for i,unit in ipairs(units) do
			local unitname = unit.strings[UNITNAME]
			
			if (unitname == "text_is") then
				table.insert(allis, unit)
			elseif (unitname == "text_stop") or (unitname == "text_push") or (unitname == "text_win") then
				table.insert(allis, unit)
			end
		end
		
		if (curris > 0) and (curris < 8) then
			if (timer % 20 == 0) then
				local flowerid = MF_specialcreate("Flower_center")
				local flower = mmf.newObject(flowerid)
				
				local unit = allis[curris]
				
				flower.strings[2] = "is"
				flower.values[10] = 2
				flower.x = unit.x
				flower.y = unit.y
				
				MF_playsound("intro_flower_" .. tostring(curris))
				
				if (curris == 7) then
					introdata.values[INTROPHASE] = 4
					introdata.values[INTROTIMER] = 0
				end
			end
		end
	elseif (phase == 4) then
		local curris = math.floor(timer / 20) - 1
		local allis = MF_findspecial("is")
		
		if (curris > 0) and (curris < 8) then
			if (timer % 20 == 0) then
				local flowerid = allis[curris]
				
				local flower = mmf.newObject(flowerid)
				
				flower.values[6] = 1
				
				if (curris == 7) then
					introdata.values[INTROPHASE] = 5
					introdata.values[INTROTIMER] = 0
				end
			end
		end
	elseif (phase == 5) then
		if (timer == 100) then
			local allis = MF_findspecial("is")
			
			for i,flowerid in ipairs(allis) do
				local flower = mmf.newObject(flowerid)
				flower.values[6] = 2
			end
			
			for i,unit in ipairs(units) do
				local unitname = unit.strings[UNITNAME]
				
				if (unitname == "text_is") or (unitname == "text_win") or (unitname == "text_stop") or (unitname == "text_push") then
					unit.visible = true
				end
			end
			
			MF_playsound("intro_disappear_1")
			introdata.values[INTROPHASE] = 6
			introdata.values[INTROTIMER] = 0
		end
	elseif (phase == 6) then
		if (timer == 80) then
			MF_playsound("intro_reverse_baba")
		end
		
		if (timer == 110) then
			
			for i,unit in ipairs(units) do
				if (unit.strings[UNITNAME] == "text_you") then
					local flowerid = MF_specialcreate("Flower_center")
					local flower = mmf.newObject(flowerid)
					
					flower.strings[2] = "you"
					flower.values[10] = 1
					flower.values[8] = 3
					flower.x = unit.x
					flower.y = unit.y
				end
			end
		elseif (timer == 280) then
			local allis = MF_findspecial("you")
			
			for i,flowerid in ipairs(allis) do
				local flower = mmf.newObject(flowerid)
				flower.values[6] = 1
			end
		end
		
		--[[
		if (timer == 135) then
			MF_playsound("intro_reverse_baba_short")
		end
		]]--
		
		if (timer > 380) then
			for i,unit in ipairs(units) do
				if (unit.strings[UNITNAME] == "tile") then
					unit.x = unit.x + math.random(-2, 2)
					unit.y = unit.y + math.random(-2, 2)
					
					if (timer % 5 == 0) then
						local tx = (unit.x - Xoffset) / tilesize
						local ty = (unit.y - Yoffset) / tilesize
						particles("bling",tx,ty,1,{1, 1},0)
					end
				end
			end
		end
		
		if (timer == 620) then
			local allis = MF_findspecial("you")
			
			for i,flowerid in ipairs(allis) do
				local flower = mmf.newObject(flowerid)
				flower.values[6] = 2
			end
			
			for i,unit in ipairs(units) do
				if (unit.strings[UNITNAME] == "tile") then
					unit.values[FLOAT] = 0
					unit.values[POSITIONING] = -10
					
					local unitref = unitreference[unit.strings[UNITNAME]]
					local thisdata = tileslist[unitref]
					local changedata = changes[unitref] or {}
					
					local c = changedata.colour or thisdata.colour
					MF_setcolour(unit.fixed, c[1], c[2])
					unit.values[ZLAYER] = thisdata.layer
				end
			end
			
			for i,unit in ipairs(units) do
				local unitname = unit.strings[UNITNAME]
				
				if (unitname == "text_you") then
					unit.visible = true
				end
				
				unit.values[A] = 0
				unit.values[VISUALDIR] = 0
			end
			
			introdata.values[INTROPHASE] = 7
			introdata.values[INTROTIMER] = 0
			generaldata.values[IGNORE] = 0
			MF_store("save","baba","firsttime",tostring(1))
		end
	elseif (phase == 7) then
		if (timer == 141) then
			introdata.values[INTROPHASE] = 0
			introdata.values[INTROTIMER] = 0
		end
	end
end

-- OLD ENDING CODE
--[[
function ending(enddataid)
	local enddata = mmf.newObject(enddataid)
	
	enddata.values[ENDTIMER] = enddata.values[ENDTIMER] + 1
	local phase = enddata.values[ENDPHASE]
	local timer = enddata.values[ENDTIMER]
	local ender = enddata.values[4]
	local ended = enddata.values[3]
	
	if (phase == 1) then
		if (timer == 2) then
			local unit = mmf.newObject(ended)
			local c1,c2 = getcolour(ended)
			MF_particles("smoke",unit.values[XPOS],unit.values[YPOS],20,c1,c2,1)
			
			unit.visible = false
			MF_playsound("drumroll")
			
			for i,unit in ipairs(units) do
				if (unit.strings[UNITTYPE] == "text") then
					unit.values[A] = math.random(0,200) * 0.0005
				end
			end
		end
		
		if (timer > 0) then
			for i,unit in ipairs(units) do
				if (unit.strings[UNITTYPE] == "text") then
					unit.x = unit.x + math.random(-1,1)
					unit.y = unit.y + math.random(-1,1)
					unit.values[POSITIONING] = 0
				end
			end
		end
		
		if (timer > 100) and (timer < 250) then
			local eunit = mmf.newObject(ended)
			local ex,ey = eunit.values[XPOS],eunit.values[YPOS]
			local texts = {}
			
			for i,unit in ipairs(units) do
				if (unit.strings[UNITTYPE] == "text") then
					table.insert(texts, unit.fixed)
				end
			end
			
			for i,unitid in ipairs(texts) do
				local unit = mmf.newObject(unitid)
				local x,y = unit.values[XPOS],unit.values[YPOS]
				
				unit.values[FLOAT] = 1
				
				local dir = 0 - math.atan2(ey - y, ex - x)
				local dist = math.abs(ey - y) + math.abs(ex - x)
				unit.values[A] = unit.values[A] + 0.002
				
				unit.values[XPOS] = x + math.cos(dir) * math.min(unit.values[A], dist)
				unit.values[YPOS] = y - math.sin(dir) * math.min(unit.values[A], dist)
				
				if (math.abs(ex - x) < 0.1) and (math.abs(ey - y) < 0.1) then
					local c1,c2 = 4,1
					local tdata = tileslist[unit.className]
					local tc = tdata.active
					c1 = tc[1]
					c2 = tc[2]
					
					MF_particles("bling",ex,ey,10,c1,c2,1)
					delete(unitid)
					updatecode = 0
				end
			end
			
			if (#texts == 0) then
				enddata.values[ENDPHASE] = 2
				enddata.values[ENDTIMER] = 0
				generaldata.values[SHAKE] = 4
				MF_stopsound("drumroll")
				MF_playsound("boom")
				
				local flowerid = MF_specialcreate("Flower_center")
				local flower = mmf.newObject(flowerid)
				
				flower.strings[1] = "you"
				flower.values[10] = 1
				flower.values[8] = 15
				flower.values[26] = 1
				flower.x = eunit.x
				flower.y = eunit.y
				
				MF_playsound("ending_reverse_baba2")
			end
		end
	end
		
	if (phase == 2) then
		if (timer == 120) then
			local allis = MF_findspecial("you")
			
			for i,flowerid in ipairs(allis) do
				local flower = mmf.newObject(flowerid)
				flower.values[6] = 3
			end
		end
		
		if (timer == 310) then
			local allis = MF_findspecial("you")
			
			for i,flowerid in ipairs(allis) do
				local flower = mmf.newObject(flowerid)
				flower.values[6] = 1
			end
		end
		
		if (timer == 570) then
			dotransition()
		elseif (timer > 570) and (generaldata.values[TRANSITIONED] == 1) then
			clearunits()
			MF_loop("clear",1)
			
			enddata.values[ENDPHASE] = 3
			enddata.values[ENDTIMER] = 0
			generaldata.values[ONLYARROWS] = 0
			--generaldata.values[IGNORE] = 1
			generaldata.values[TRANSITIONED] = 0
			
			local xoffset = (screenw - roomsizex * tilesize * spritedata.values[TILEMULT]) * 0.5
			local yoffset = (screenh - roomsizey * tilesize * spritedata.values[TILEMULT]) * 0.5
			
			MF_setroomoffset(xoffset,yoffset)
			MF_loadbackimage("island,island_decor")
			levelborder()
			
			local flowerid = MF_specialcreate("Flower_center")
			local flower = mmf.newObject(flowerid)
			
			flower.strings[1] = "you"
			flower.values[10] = 1
			flower.values[8] = 1
			flower.values[6] = 1
			flower.x = tilesize * 16 * spritedata.values[TILEMULT]
			flower.y = tilesize * 14 * spritedata.values[TILEMULT]
		end
	end
	
	if (phase == 3) then
		if (timer == 150) then
			dotransition()
		elseif (timer > 150) and (generaldata.values[TRANSITIONED] == 1) then
			clearunits()
			MF_loop("clear",1)
			MF_setmode(2)
			enddata.values[ENDPHASE] = 0
			enddata.values[ENDTIMER] = 0
		end
	end
end
]]--